<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve 3 question of satck</p>
		<button onclick="absoluteDiffrence()">print absolute diffrence</button>
		<p id="demo"></p>

		<script>
			function absoluteDiffrence() {
				class Stack {
				// Array is used to implement stack
					constructor() {
						this.items = [];
					}
				
					// push function
					push(element) {
						// push element into the items
						this.items.push(element);
					}
				
					// pop
					pop() {
						// function return top most element in the stack and removes it from the stack Underflow if stack is empty
						if(this.items.length == 0)
							return "Underflow";
						return this.items.pop();
					}
				
					// peek function
					peek() {
						// return the top most element from the stack but does'nt delete it.
						return this.items[this.items.length - 1];
					}
					
					// isEmpty function
					isEmpty() {
						// return true if stack is empty
						return this.items.length == 0;
					}

				}
				

                // Prints smaller elements on left side of every element 
                function absoluteDiffrenceArray(arr,n) { 
                    // creating object for stack class
				    var stackLeftNearestSmall = new Stack();
                    var stackRightNearestSmall = new Stack();
                    var nearLeftSmall = [];
                    var nearRightSmall = [];
                    var absoluteDiffrence = [];
                    // Traverse all array elements 
                    for (var i=0; i<n; i++) { 
                        // removing top element from Stack while the top element is greater than or equal to arr[i] 
                        while (!stackLeftNearestSmall.isEmpty() && stackLeftNearestSmall.peek() >= arr[i]) 
                            stackLeftNearestSmall.pop(); 
                
                        // If all elements in S were greater than arr[i] 
                        if (stackLeftNearestSmall.isEmpty()) 
                            nearLeftSmall[i] = 0; 
                        else {
                             //Else print the nearest smaller element 
                             nearLeftSmall[i] = stackLeftNearestSmall.peek();
                        }
                        // Push this element 
                        stackLeftNearestSmall.push(arr[i]); 
                    } 

                    // Traverse all array elements 
                    for (var i=n-1; i>=0; i--) { 
                        // removing top element from Stack while the top element is greater than or equal to arr[i] 
                        while (!stackRightNearestSmall.isEmpty() && stackRightNearestSmall.peek() >= arr[i]) 
                            stackRightNearestSmall.pop(); 
                
                        // If all elements in S were greater than arr[i] 
                        if (stackRightNearestSmall.isEmpty()) 
                            nearRightSmall[i] = 0; 
                        else {
                            //Else print the nearest smaller element 
                            nearRightSmall[i] = stackRightNearestSmall.peek();
                        }
                        // Push this element 
                        stackRightNearestSmall.push(arr[i]); 
                    }
                    for(var i=0;i<n;i++)
                        absoluteDiffrence[i] = Math.abs(nearRightSmall[i] - nearLeftSmall[i]); 
                    console.log("absolute diffrence array = "+absoluteDiffrence);
                }

                //create an array
                var array = [2,4,7,3,9,1,6,8,10];
                console.log("your given array is = "+array);
                absoluteDiffrenceArray(array,array.length);

		}
		</script>

	</body>
</html>